#!/bin/bash
#
# SmartVista SVIG startup script
#
# chkconfig: - 74 12
# description: svig


####### START OF THE CONFIG SECTION ##########

#--------------------
#Application parameters
APP_JAR_FILE=ru.bpc.paymentsense.svig.ui.jar
{% if instance == 'prod' %}
APP_CONFIG_FILE=application-oracle.yml
{% else %}
APP_CONFIG_FILE=application-oracle.properties
{% endif %}
APP_PROXY_SETTINGS="{{ svig_app_proxy_settings|default('') }}"
APP_MEMORY_SETTINGS="-Xmx1024m"
APP_OTHER_SETTINGS="-Dhttps.protocols=TLSv1.2 -Dfile.encoding=UTF-8 -Djava.net.preferIPv4Stack=true -Djavax.xml.transform.TransformerFactory=com.sun.org.apache.xalan.internal.xsltc.trax.TransformerFactoryImpl -Djavax.xml.parsers.DocumentBuilderFactory=com.sun.org.apache.xerces.internal.jaxp.DocumentBuilderFactoryImpl -Djavax.xml.parsers.SAXParserFactory=com.sun.org.apache.xerces.internal.jaxp.SAXParserFactoryImpl"
# Remote debugging
APP_REMOTE_DEGUG="-agentlib:jdwp=transport=dt_socket,server=y,suspend=n,address=5005"
# JMX
APP_JMX_SETTINGS="-Dcom.sun.management.jmxremote -Dcom.sun.management.jmxremote.port=8857 -Dcom.sun.management.jmxremote.ssl=false -Dcom.sun.management.jmxremote.authenticate=false -Dcom.sun.management.jmxremote.local.only=false -Dcom.sun.management.jmxremote.rmi.port=8857 -Djava.rmi.server.hostname={{ ansible_host }}"

prog=svig

WLS_USER=weblogic
HOME_FOLDER=`grep "^${WLS_USER}:" /etc/passwd | cut -d ':' -f 6`
APP_JAVA={{ java_path|default(oci_java_path) }}
SVIG_HOME=${HOME_FOLDER}/svig

# Log files
SVIG_LOG_FILE=/dev/null
if [ "${DEBUG}" == "TRUE" ]
    then
        SVIG_LOG_FILE={{ svig_log_file }}
fi


#-------------------------------------------
#If running in Cluster environment set USE_CLUSER variable to TRUE otherwise set it to FALSE.
USE_CLUSTER="TRUE"


#Do we need to add VIP (Virtual IP) address first?
USE_VIP=NO
VIP_ADDR=172.30.42.113
VIP_MASK=26
VIP_DEV=ens32
GW_IP=172.30.42.65


SHUT_MSG="SmartVista SVIG shutdown succeeded"

LOCK_FILE=/tmp/svig

############# END OF THE CONFIG SECTION #################

if [ -e ${HOME_FOLDER}/.bash_profile ]
        then
                USER_PROFILE=${HOME_FOLDER}/.bash_profile
        else
                USER_PROFILE=${HOME_FOLDER}/.profile
fi

create_lock_file() {

if [ "$USE_CLUSTER" == "FALSE" ]

        then

                #Create lock file to exclude multiple instances of the script
                if [ -e $LOCK_FILE ]
                        then
                                echo "Another instance of the script running... Or check for lock file: $LOCK_FILE"
                                exit 255
                fi

                touch $LOCK_FILE

        else
                echo ""
                echo "Assuming using script in the Cluster Environment"
                echo "Multiply instances of script is permitted. Cluster must take care about it"
                echo ""
fi
}

remove_lock_file() {
if [ "$USE_CLUSTER" == "FALSE" ]
        then
                rm -f $LOCK_FILE
fi
}


case `uname` in
    AIX)
        OS=AIX
        GREP=/usr/bin/grep
        SHUT_LOG_CMD="/usr/bin/logger -puser.debug -t svig '${SHUT_MSG}'"
        PCMD="ps -f -u $WLS_USER | $GREP -v grep | $GREP $APP_JAR_FILE | awk '{print \$2}'"
        KILL_CMD="xargs kill"
        KILL_CMD_9="xargs kill -9"

                case "$USER" in
                        root)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &\""

                        ;;

                        ${WLS_USER})

                                START_CMD=". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &"
                        ;;

                        *)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &\""
                        ;;
                esac
    ;;

    Linux)
        OS=Linux
        SHUT_LOG_CMD="/usr/bin/logger -t activemq '${SHUT_MSG}'"
        PCMD="pgrep -u $WLS_USER -f $APP_JAR_FILE"
        KILL_CMD="xargs kill"
        KILL_CMD_9="xargs kill -9"

        case "$USER" in
            root)

                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &\""

                ADD_VIP="ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"


            ;;

            ${WLS_USER})

                START_CMD=". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &"

                ADD_VIP="sudo ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="sudo ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"

            ;;

            *)

                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &\""

                ADD_VIP="ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"
            ;;
        esac

    ;;

    SunOS)
        OS=SunOS
        SHUT_LOG_CMD="/usr/bin/logger -t svig '${SHUT_MSG}'"
        PCMD="pgrep -u $WLS_USER -f $APP_JAR_FILE"

        KILL_CMD="xargs kill"
        KILL_CMD_9="xargs kill -9"

                case "$USER" in
                        root)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &\""

                        ;;

                        ${WLS_USER})

                                START_CMD=". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &"
                        ;;

                        *)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1; cd $SVIG_HOME; nohup $APP_JAVA $APP_OTHER_SETTINGS $APP_MEMORY_SETTINGS $APP_JMX_SETTINGS $APP_PROXY_SETTINGS -jar ${SVIG_HOME}/$APP_JAR_FILE > $SVIG_LOG_FILE 2>&1 &\""
                        ;;
                esac
    ;;

    *)
        echo "Cant determine OS"
    ;;
esac;


grep JAVA_HOME $USER_PROFILE >/dev/null 2>&1

if [ $? -ne 0 ]
    then
        echo "JAVA_HOME variable is not specified, please add it into users profile"
        echo "It is needed for correct stop"
fi

EXIT_CODE=0

add_vip_addr() {

        if [ $USE_VIP == YES ]
                then
                        echo "Adding Virtual IP address"
                        eval $ADD_VIP
                        sleep 2
                        echo "Pinging Default Gateway"
                        eval $PING_GW
                        sleep 2
                        echo "Sending gratious ARP"
                        eval $PING_ARP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}

remove_vip_addr() {
        if [ $USE_VIP == YES ]
                then
                        echo "Deleting Virtual IP address"
                        eval $DEL_VIP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}


start() {
        echo "Starting $prog: "
    eval $START_CMD
        if [ $? -eq 0 ]
                then
                        EXIT_CODE=0
                else
                        EXIT_CODE=255
        fi

}

stop() {
    echo "Stopping $prog: "

    eval $PCMD | $KILL_CMD
    sleep 10
    PCMD_RESULT=`eval $PCMD | wc -l`
    if [ $PCMD_RESULT -gt 0 ]
        then
            eval $PCMD | $KILL_CMD_9
    fi

        if [ $? -eq 0 ]
                then
                        EXIT_CODE=0
            eval $SHUT_LOG_CMD
                else
                        EXIT_CODE=255
        fi
}

status () {
    PCMD_RESULT=`eval $PCMD | wc -l`
    if [ $PCMD_RESULT -eq 1 ]
        then
            PCMD_RESULT=`eval $PCMD`
                if [ "${PCMD_RESULT}x" != "x" ] && [ $PCMD_RESULT -gt 0 ]
                        then
                                echo "$prog is running"
                    EXIT_CODE=0
                        else
                                echo "$prog is not running"
                    ### To be compatible with Veritas Cluster
                        EXIT_CODE=100
            fi
        else
            echo "$prog status is unknown, zero or more than one instance found"
            ### To be compatible with Veritas Cluster
            EXIT_CODE=100
        fi
}

case "$1" in
        start)
        if [ "$UNAME" == "Linux" ] && [ $LINUX_RELEASE -lt 7 ]
            then
                touch /var/lock/subsys/wls${WLS_VERSION}
        fi
        create_lock_file
        add_vip_addr
                start
        remove_lock_file
        ;;
        stop)
        create_lock_file
                stop
        remove_vip_addr
        remove_lock_file
        ;;
        status)
                status
        ;;
        add_vip)
                create_lock_file
                add_vip_addr
                remove_lock_file
        ;;

        del_vip)
                create_lock_file
                remove_vip_addr
                remove_lock_file
        ;;
        *)
        echo "Usage: $0 {start,stop,status}"
        exit 1
esac

if [ $EXIT_CODE -eq 0 ]
    then
        echo "Succeed"
    else
        echo "Failed"
fi
exit $EXIT_CODE
